#include "iodefine.h"

//KbBuffer\̂̃rbgtOǗׂ̃}N
#define KSSHIFT 	1
#define KSCTRL		2
#define KSALT		4

//ꕶ̃XLER[h
#define KRSHIFT		0x59
#define	KLSHIFT		0x12
#define KALT		0x11
#define	KCTRL		0x14
#define FUNCTION7	0x83
#define BREAK		0xF0

struct KbBuffer{
	char	Buff[16];	//obt@
	char	Rp;			//Ƀf[^ǂݍBuff̈ʒu
	char	Wp;			//Ƀf[^[Buff̈ʒu
	char	Cnt;		//BuffɃX^bNĂf[^̐
	char	Size;		//Buff̗vf
	char	Shift;		//ALTACTRLASHIFT̏[rbgtO
};

struct KbBuffer PS2Buf;

/*--------------------------------------------------------------------------------------
擾L[ER[hCHAR^ɕϊׂ̔z
---------------------------------------------------------------------------------------*/
const unsigned char KeyTbl[128]={
		0,0xf9,0,0xf5,0xf3,0xf1,0xf2,0xfc,0,0xfa,0xf8,0xf6,0xf4,9,0xfd,0,	//00-0F
		0,0,0,0,0,'q','1',0,0,0,'z','s','a','w','2',0,						//10-1F
		0,'c','x','d','e','4','3',0,0,0x20,'v','f','t','r','5',0,			//20-2F
		0,'n','b','h','g','y','6',0,0,0,'m','j','u','7','8',0,				//30-3F
		0,',','k','i','o','0','9',0,0,'.','/','l',';','p','-',0,				//40-4F
		0,'\\',':',0,'@','^',0,0,0,0,0x0d,'[',0,']',0,0,					//50-5F
		0,0,0,0,0,0,8,0,0,'1','\\','4','7',0,0,0,							//60-6F
		'0','.','2','5','6','8',0x1b,0,0xfb,'+','3','-','*','9',0,0			//70-7F
};

/*--------------------------------------------------------------------------------------
擾L[ER[hCHAR^ɕϊׂ̔ziSHIFTL[pj
---------------------------------------------------------------------------------------*/
const unsigned char SKeyTbl[128]={
		0,0xf9,0,0xf5,0xf3,0xf1,0xf2,0xfc,0,0xfa,0xf8,0xf6,0xf4,9,0xfd,0,	//00-0F
		0,0,0,0,0,'Q','!',0,0,0,'Z','S','A','W',0x22,0,						//10-1F
		0,'C','X','D','E','$','#',0,0,0x20,'V','F','T','R','%',0,			//20-2F
		0,'N','B','H','G','Y','&',0,0,0,'M','J','U',0x27,'(',0,				//30-3F
		0,'<','K','I','O','~',')',0,0,'>','?','L','+','P','=',0,				//40-4F
		0,'|','*',0,'`','~',0,0,0,0,0x0d,'{',0,'}',0,0,						//50-5F
		0,0,0,0,0,0,8,0,0,'!','|',0xe4,0xe9,0,0,0,							//60-6F
		0xe0,'.',0xe2,0,0xe5,0xe3,0x1b,0,0xfb,'+',0xe8,'-','*',0xe7,0,0		//70-7F
};

/*--------------------------------------------------------------------------------------
֐F	PS2Putkey
@\F		XLER[hASCIIR[hɕϊ
---------------------------------------------------------------------------------------*/
void PS2Putkey(unsigned char c)
{
	static char IsKeyUp=0;	//̃rbg1̎Aɂf[^BreakR[h
	unsigned char key=0;

	if(IsKeyUp){	//BreakR[h̏
		switch(c){
		case KLSHIFT:
		case KRSHIFT:
			PS2Buf.Shift &= ~KSSHIFT;
			break;
		case KCTRL:
			PS2Buf.Shift &= ~KSCTRL;
			break;
		case KALT:
			PS2Buf.Shift &= ~KSALT;
			break;
		}
		IsKeyUp=0;
	}else{			//MakeR[h̏
		if(c==FUNCTION7){
			key=0xf7;
		}else if(c>=0x80){
			if(c==BREAK){
				IsKeyUp=1;
			}
			return;
		}else{
			switch(c){
			case KLSHIFT:
			case KRSHIFT:
				PS2Buf.Shift |= KSSHIFT;
				break;
			case KCTRL:
				PS2Buf.Shift |= KSCTRL;
				break;
			case KALT:
				PS2Buf.Shift |= KSALT;
				break;
			default:
				if(PS2Buf.Shift & KSCTRL){
					key=KeyTbl[c]-'a'+1;
				}else if(PS2Buf.Shift & KSSHIFT){
					key=SKeyTbl[c];
				}else{
					key=KeyTbl[c];
				}
			}
		}
	}
}

/*--------------------------------------------------------------------------------------
֐F	PS2flush
@\F		obt@B
---------------------------------------------------------------------------------------*/
void PS2Flash()
{
	PS2Buf.Rp=0;
	PS2Buf.Wp=0;
	PS2Buf.Cnt=0;
	PS2Buf.Shift=0;
	PS2Buf.Size=16;
}

/*--------------------------------------------------------------------------------------
֐F	PS2dgetc
@\F		obt@f[^o
---------------------------------------------------------------------------------------*/
unsigned int PS2dgetc()
{
	int retc;
	if(PS2Buf.Cnt<=0)
		return -1;
	retc=PS2Buf.Buff[PS2Buf.Rp];
	PS2Buf.Rp=(PS2Buf.Rp+1)%PS2Buf.Size;
	PS2Buf.Cnt--;
	return retc;
}

/*--------------------------------------------------------------------------------------
֐F	PS2getc
@\F		obt@ɂȂ܂ŁiႵ1000JԂ܂Łjobt@f[^oB
---------------------------------------------------------------------------------------*/
unsigned int PS2getc()
{
	int i;
	int retc;
	retc=PS2dgetc();
	while(retc==-1){
		for(i=0;i<1000;i++) ;
		retc=PS2dgetc();
	}
	return retc;
}

/*--------------------------------------------------------------------------------------
֐F	PS2Init
@\F		֐
---------------------------------------------------------------------------------------*/
void PS2Init()
{
	PS2Flash();
	IO.PCR8=0x7f;	//Bit7=Input,Other=Output
	IO.PMR1.BIT.IRQ1=1;
	IEGR1.BIT.IEG1=1;
	IENR1.BIT.IEN1=1;
}

/*--------------------------------------------------------------------------------------
֐F	PS2Int
@\F		IRQ1荞݂Ŏs֐
			IRQ1iP15jPS/2RlN^5ԃsiNbNjɐڑĂ܂B
---------------------------------------------------------------------------------------*/
void PS2Int(void)
{
	static char bitcnt=0;
	static unsigned char dat=0;
	static char IsBreak;
	unsigned char dbit;

	IRR1.BIT.IRRI1=0;
	dbit=IO.PDR8.BYTE;	// & 0x80;	//P87PS/2̃f[^
	if(bitcnt==0){
		if(!dbit)		//X^[grbgłΓǂݎJn
			bitcnt++;
		return;
	}
	switch(bitcnt){
	case 9:				//peBErbgBȂB
		break;
	case 10:			//XgbvErbgBXgbvErbĝ̏͂A擾f[^\̂Ɏ[
		PS2Putkey(dat);
		bitcnt=0;
		break;
	default:
		dat=(dat >> 1) | dbit;		//datփVtgWX^IɎ[
	}
	if(bitcnt)
		bitcnt++;
}
