/*================================
	I2C ANZXpW[
================================*/
#include "iodefine.h"
#include "i2c.h"

#define true  1
#define false 0

//I2CC^[tF[X̃[hݒ
int I2CMode(int mode)
{
	//Mode=0:Read,1:Write
	IIC2.ICCR1.BIT.ICE = 1;
	IIC2.ICCR1.BIT.MST = 1;
	IIC2.ICCR1.BIT.TRS = mode;
	return true;
}

// StartCondition̔s
int StartCondition()
{
	IIC2.ICCR2.BYTE=0xBD;	//Send Start Condition
	return true;
}

// StopCondition̔s
int StopCondition()
{
	IIC2.ICCR2.BYTE=0x3D;	//Send Stop Condition
	while(!IIC2.ICSR.BIT.STOP);
	return true;
}

//1oCg̏݁BACKoG[̎0iFALSE)ƂȂ
int ByteWrite(unsigned char dat)
{
	IIC2.ICDRT=dat;	//1oCgM
	//M҂
	while(!IIC2.ICSR.BIT.TEND);
	if(IIC2.ICIER.BIT.ACKBR)	//ACKԂȂꍇiACK=0Őj̓G[
		return false;
	return true;
}

//1oCg̓ǂݏo
int ByteRead()
{
	unsigned short dat;

	IIC2.ICSR.BIT.TDRE=0;
	IIC2.ICIER.BIT.ACKBT=1;
	dat=IIC2.ICDRR;		//MJn̂߂̃_~[[h
	while(!IIC2.ICSR.BIT.RDRF);	//M܂ő҂
	IIC2.ICCR1.BIT.RCVD=1;
	dat=IIC2.ICDRR;	
	return (int)dat;
}

void WaitRDRF()
{
	while(!IIC2.ICSR.BIT.RDRF);	//M܂ő҂
}
	
#if 0
//M̊Jn
int ReadStart()
{
	unsigned short dat;
	dat=IIC2.ICDRR;	
	return (int)dat;
}
#endif